package org.netkernel.nkse.search.endpoint;
import java.io.File;

import org.netkernel.container.config.IConfiguration;
import org.netkernel.layer0.boot.BootUtils;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;


public class SearchConfigAccessor extends StandardAccessorImpl
{
	public SearchConfigAccessor()
	{	this.declareThreadSafe();
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	String searchDir=null;
		IConfiguration config=context.getKernelContext().getKernel().getConfiguration();
		if(BootUtils.bootedFromJar(config))
		{	File temp=File.createTempFile("NKSE-Search-Temp"+System.currentTimeMillis(), null);
			File tempDir=temp.getParentFile();
			temp.delete();
			File searchDirFile=new File(tempDir, "NKSE-Search-Index"+System.currentTimeMillis()+File.pathSeparator);
			searchDirFile.mkdir();
			searchDir=searchDirFile.toURI().toString();
		}
		else
		{	String base=BootUtils.getInstallPath(config);
			searchDir=base+"/searchIndex/";
		}
	 	HDSBuilder b=new HDSBuilder();
		b.pushNode("config");
			b.addNode("directory",searchDir);
		b.popNode();
		context.createResponseFrom(b.getRoot());
	}

	@Override
	public void onExists(INKFRequestContext context) throws Exception
	{	context.createResponseFrom(Boolean.TRUE);
	}
	
}
