package org.netkernel.text.search.endpoint;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.Query;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer1.representation.IDeterminateStringRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class DefaultStringToQueryTransreptor extends StandardTransreptorImpl
{	
	public static final String DEFAULT_FIELD_NAME="default";
	
	public DefaultStringToQueryTransreptor()
	{	this.declareThreadSafe();
		this.declareToRepresentation(Query.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IDeterminateStringRepresentation queryString=context.sourcePrimary(IDeterminateStringRepresentation.class);
		QueryParser qp=new QueryParser(DEFAULT_FIELD_NAME, new StandardAnalyzer());
		Query q=qp.parse(queryString.getString());
		context.createResponseFrom(q);
	}

}
