package org.netkernel.text.search.endpoint;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.text.search.representation.LuceneConfigRep;

public class LuceneConfigTransreptor extends StandardTransreptorImpl
{
	public LuceneConfigTransreptor()
	{	this.declareThreadSafe();
		this.declareToRepresentation(LuceneConfigRep.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IHDSNode hds=context.sourcePrimary(IHDSNode.class);
		IHDSNode n=hds.getFirstNode("/config/analyzerClass");
		Analyzer a=null;
		if(n==null)
		{	a=new StandardAnalyzer();
		}
		else
		{	String aclass=(String)n.getValue();	
			a=(Analyzer)Class.forName(aclass).newInstance();
		}
		n=hds.getFirstNode("/config/directory");
		String d=null;
		if(n!=null)
		{	d=(String)n.getValue();
		}
		n=hds.getFirstNode("/config/maxFieldLength");
		int m=25000;
		if(n!=null)
		{	m=Integer.parseInt((String)n.getValue());
		}
		context.createResponseFrom(new LuceneConfigRep(a,d,m));
	}
}
